local clock = function() return love.timer.getTime()*1000 end
--local clock = function() return os.clock()*1000 end

function test(func, ...)
  collectgarbage("collect")
  local m1 = collectgarbage("count")
  local t1 = clock()
  func(...)
  local t2 = clock()
  local m2 = collectgarbage("count")
  return t2 - t1, m2 - m1
end

local tests = {}

local L_pairs = pairs
function tests.L_pairs(t)
  for k,v in L_pairs(t) do end
end

function tests.G_pairs(t)
  for k,v in pairs(t) do end
end

local L_ipairs = ipairs
function tests.L_ipairs(t)
  for k,v in L_ipairs(t) do end
end

function tests.G_ipairs(t)
  for k,v in ipairs(t) do end
end

local L_next = next
function tests.L_next(t)
  for k,v in L_next,t do end
end

function tests.G_next(t)
  for k,v in next,t do end
end

function tests.numeric(t)
  for i = 1, #t do local v = t[i] end
end

local tbl1, tbl2 = { }, { }
for i = 1, 1000000 do
  tbl1["id:" .. i] = i
  tbl2[i] = i
end

function love.load()
  print('table')
  for k, v in pairs(tests) do
    local dt, dm = test(v, tbl1)
    local res = string.format("%s  %f  %f", k, dt, dm)
    print(res)
  end

  print('list')
  for k, v in pairs(tests) do
    local dt, dm = test(v, tbl2)
    local res = string.format("%s  %f  %f", k, dt, dm)
    print(res)
  end
end